﻿System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClose;

document.onselectstart = function() {return false};

var size;
var factheight;
var timervar;
var refreshRate = 100; //update every 100 ms
var hidedateflag;
var hidetitleflag;
var hidecopyrightflag;
var autoscaleDPIflag;

//color settings
var cBgColor;
var cTitle;
var cTime;
var cCopyright;
var cVersion;

function init(){
 loadsettingsfromfile(); //don't move this line!!!
 loadSettings();
 if (autoscaleDPIflag) getDPIsize(); ////Important!!! After loadsettings()
 setupgadget();
 DozenalClock();
}

function loadsettingsfromfile(){
 var fs = new ActiveXObject("Scripting.FileSystemObject");
 var inifilename = System.Environment.getEnvironmentVariable("APPDATA") + "\\" + System.Gadget.name + "_Settings.ini";
 try {
  var inifile = fs.OpenTextFile(inifilename, 1); //1 read
   try {
    var tmp = inifile.ReadLine();
    tmp = inifile.ReadLine();
    if (tmp != ";purr meow") throw "old";

    //color settings
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sBgColorSelect", tmp);
    cBgColor = inifile.ReadLine();
    System.Gadget.Settings.write("colBgColor", cBgColor);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sTitColorSelect", tmp);
    cTitle = inifile.ReadLine();
    System.Gadget.Settings.write("colTitle", cTitle);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sDateTimeColorSelect", tmp);
    cTime = inifile.ReadLine();
    System.Gadget.Settings.write("colTime", cTime);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sVersnColorSelect", tmp);
    cVersion = inifile.ReadLine();
    System.Gadget.Settings.write("colVersion", cVersion);
    tmp = inifile.ReadLine();
    System.Gadget.Settings.write("sCopyColorSelect", tmp);
    cCopyright = inifile.ReadLine();
    System.Gadget.Settings.write("colCopyright", cCopyright);
    //color settings end

    size = inifile.ReadLine();
    System.Gadget.Settings.write("SetSize", size);
    hidedateflag = inifile.ReadLine();
    System.Gadget.Settings.write ("DateHide", hidedateflag);
    hidetitleflag = inifile.ReadLine();
    System.Gadget.Settings.write ("TitleHide", hidetitleflag);
    hidecopyrightflag = inifile.ReadLine();
    System.Gadget.Settings.write ("CopyrightHide", hidecopyrightflag);
    autoscaleDPIflag = inifile.ReadLine();
    System.Gadget.Settings.write ("DPIautoscale", autoscaleDPIflag);
  }//end try 2
  
   finally {inifile.Close()}
 }//end try 1
 
 catch (e) {}

 finally {fs = null}
}
 
function loadSettings(){
 size = System.Gadget.Settings.read("SetSize");
 if(size == ''){
  size = "1";
  System.Gadget.Settings.write("SetSize", size);
 }

 autoscaleDPIflag = System.Gadget.Settings.read ("DPIautoscale");
 if (autoscaleDPIflag != "false"){
  autoscaleDPIflag = true;
  System.Gadget.Settings.write ("DPIautoscale", "true");
 }
 else{
  autoscaleDPIflag = false;
  System.Gadget.Settings.write ("DPIautoscale", "false");
 }

 hidedateflag = System.Gadget.Settings.read ("DateHide");
 if (hidedateflag != "true"){
  hidedateflag = false;
  System.Gadget.Settings.write ("DateHide", "false");
 }
 else{
  hidedateflag = true;
  System.Gadget.Settings.write ("DateHide", "true");
 }

 hidetitleflag = System.Gadget.Settings.read ("TitleHide");
 if (hidetitleflag != "true"){
  hidetitleflag = false;
  System.Gadget.Settings.write ("TitleHide", "false");
 }
 else{
  hidetitleflag = true;
  System.Gadget.Settings.write ("TitleHide", "true");
 }
 hidecopyrightflag = System.Gadget.Settings.read ("CopyrightHide");
 if (hidecopyrightflag != "true"){
  hidecopyrightflag = false;
  System.Gadget.Settings.write ("CopyrightHide", "false");
 }
 else{
  hidecopyrightflag = true;
  System.Gadget.Settings.write ("CopyrightHide", "true");
 }

 //color settings
 cBgColor = System.Gadget.Settings.read("colBgColor");
 if (cBgColor == ''){
  cBgColor = "#262526";
  System.Gadget.Settings.write("colBgColor", cBgColor);
 }
 cTitle = System.Gadget.Settings.read("colTitle");
 if (cTitle == ''){
  cTitle = "#FFFFFF";
  System.Gadget.Settings.write("colTitle", cTitle);
 }
 cTime = System.Gadget.Settings.read("colTime");
 if (cTime == ''){
  cTime = "#FFCC00";
  System.Gadget.Settings.write("colTime", cTime);
 }
 cCopyright = System.Gadget.Settings.read("colCopyright");
 if (cCopyright == ''){
  cCopyright = "#00CCFF";
  System.Gadget.Settings.write("colCopyright", cCopyright);
 }
 cVersion = System.Gadget.Settings.read("colVersion");
 if (cVersion == ''){
  cVersion = "#C0C0C0";
  System.Gadget.Settings.write("colVersion", cVersion);
 }
 //color settings end
}

function getDPIsize(){
 try{
  var wshShell = new ActiveXObject("WScript.Shell");
  var getdefaultDPI = wshShell.RegRead("HKCU\\Control Panel\\Desktop\\LogPixels");
  size = parseInt((getdefaultDPI / 96) * 100) / 100;
  System.Gadget.Settings.write("SetSize", size);
 }
 catch (e){}
}

function settingsClose(){
 clearTimeout(timervar);
 loadSettings();
 if (autoscaleDPIflag) getDPIsize(); //Important!!! After loadsettngs()
 setupgadget();
 DozenalClock();
}

function setupgadget(){
 //fixed bug with 100% width BEFORE set real width in background section
 document.body.style.width = parseInt(130 * size);
 background.style.width = parseInt(130 * size);

 gtitle.style.visibility = "visible";
 gline.style.visibility = "visible";
 datehere.style.visibility = "visible";

 //top section
 gtitle.style.top = parseInt(6 * size);
 gline.style.top = parseInt(16 * size);
 datehere.style.top = parseInt(26 * size);
 Dozenaltimehere.style.top = parseInt(38 * size);
 advertis.style.top = parseInt(56 * size);
 versionnumber.style.top = parseInt(56 * size);

 //left section
 advertis.style.left = parseInt(8 * size);

 //font-size section
 gtitle.style.fontSize = parseInt(11 * size);
 datehere.style.fontSize = parseInt(11 * size);
 Dozenaltimehere.style.fontSize = parseInt(15 * size);
 advertis.style.fontSize = parseInt(10 * size);
 versionnumber.style.fontSize = parseInt(9 * size);

 //width section 
 versionnumber.style.width = parseInt(122 * size);

 //color settings
 gtitle.style.color = cTitle;
 datehere.style.color = cTime;
 Dozenaltimehere.style.color = cTime;
 copyright.style.color = cCopyright;
 versionnumber.style.color = cVersion;

 var k;
 factheight = 76; 

 if (hidetitleflag){
  //title
  gtitle.style.visibility = "hidden";
  gline.style.visibility = "hidden";

  k=datehere.style.top;
  datehere.style.top = parseInt(k)-parseInt(20 * size);
  k=Dozenaltimehere.style.top;
  Dozenaltimehere.style.top = parseInt(k)-parseInt(20 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(20 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(20 * size);

  factheight -= 20;
 }

 if (hidedateflag){
  //date
  datehere.style.visibility = "hidden";
 
  k=Dozenaltimehere.style.top;
  Dozenaltimehere.style.top = parseInt(k)-parseInt(12 * size);
  k=advertis.style.top;
  advertis.style.top = parseInt(k)-parseInt(12 * size);
  k=versionnumber.style.top;
  versionnumber.style.top = parseInt(k)-parseInt(12 * size);

  factheight -= 12;
 }

 if (hidecopyrightflag){
  //copyright
  advertis.style.visibility = "hidden";
  versionnumber.style.visibility = "hidden";
  factheight -= 12;
 }
 else{
  advertis.style.visibility = "visible";
  versionnumber.style.visibility = "visible";
 }

 //background section
 document.body.style.height = parseInt(factheight * size);
 background.style.height = parseInt(factheight * size);

 mainsquare.style.top = parseInt(5 * size); 
 mainsquare.style.left = parseInt(5 * size);  
 mainsquare.style.width =  parseInt((130 - 10) * size);
 mainsquare.style.height = parseInt((factheight - 10) * size);
 mainsquare.style.background = cBgColor;
}

function DozenalClock(){
 var time = new Date();
 koef = (time.getMilliseconds() + time.getSeconds() * 1000 + time.getMinutes() * 60000 + time.getHours() * 3600000) / 86400000;
 var a = 429981696 * koef; //converted 100000000 FROM base 12 TO base 10
 var h = 35831808;         //converted 10000000 FROM base 12 TO base 10
 var m = 248832;           //converted 1000000 FROM base 12 TO base 10
 var s = 1728;             //converted 1000 FROM base 12 TO base 10
 dHour = parseInt(a / h);
 dMin = parseInt((a - dHour * h) / m);
 dSec = parseInt((a - dHour * h - dMin * m) / s);
 datehere.innerText = time.toDateString();
 var dtime = dHour.toString(12) + ':' + (dMin < 12 ? "0" + dMin.toString(12) : dMin.toString(12)) + ':' + (dSec < 12 ? "0" + dSec.toString(12) : dSec.toString(12));
 Dozenaltimehere.innerText = dtime.replace(/a/g,'Ϫ').replace(/b/g,'Ɛ');

 timervar = setTimeout("DozenalClock()",refreshRate);
}